package com.zhongshu.reward.server.core.dao.Impl;

import com.zhongshu.reward.client.type.ReceiptsStatus;
import com.zhongshu.reward.client.type.ReceiptsType;
import com.zhongshu.reward.server.core.dao.WalletReceiptsDao;
import com.zhongshu.reward.server.core.dao.extend.WalletReceiptsDaoExtend;
import com.zhongshu.reward.server.core.domain.WalletReceipts;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;

import java.util.List;

/**
 * @author wjf
 * @date 2024/8/12
 */
public class WalletReceiptsDaoImpl implements WalletReceiptsDaoExtend {

    @Autowired
    MongoTemplate mongoTemplate;

    @Override
    public List<WalletReceipts> inviteDetail(String inviteUserId, Long startTime, Long endTime) {
        Criteria criteria = new Criteria();
        if (null != startTime){
            criteria.and("createTime").gte(startTime);
        }

        if (null != endTime){
            criteria.and("createTime").lte(endTime);
        }

        if (StringUtils.isNotEmpty(inviteUserId)){
            criteria.and("inviteUserId").is(inviteUserId);
        }
        Query query = Query.query(criteria);
        query.with(Sort.by(Sort.Order.desc("createTime")));

        return mongoTemplate.find(query, WalletReceipts.class);
    }

    @Override
    public List<WalletReceipts> listMonth(Long startTime, Long endTime) {
        Criteria criteria = new Criteria();

        criteria.and("createTime").gte(startTime);



        criteria.and("createTime").lte(endTime);


        criteria.and("ReceiptsType").is(ReceiptsType.COMMISSION);
        criteria.and("status").is(ReceiptsStatus.WAIT);
        Query query = Query.query(criteria);
        query.with(Sort.by(Sort.Order.desc("createTime")));

        return mongoTemplate.find(query, WalletReceipts.class);
    }
}
